// elevator.h contains the class definitions for HW1 #4


#ifndef ELEVATOR_H
#define ELEVATOR_H

#include "utility.h"
#include "synch.h"

enum Direction {Up, Down };


class Floor {
 public:
  Floor(int num);
  Condition *waitToGoUp, *waitToGoDown;
  Lock *floorLock;
  int numGoingUp, numGoingDown;
  int floorNum;
};


class Building {
 public:
  Building(int howManyFloors);
  Floor **floors;  //array of instances of class Floor
  int numFloors;
};



class Person {
 public:
  Person(int nameNum);
  void GoingFromTo(int atFloor, int toFloor);
 private:
  int name;
};


class Elevator {
 public:
  Elevator(int floors);
  void TurnOn(int trips);
  bool isTimeToClose();
  Lock *doorLock;
  Condition *inElevator, *okToCloseDoor;
  int currentFloor;
  int numRidersToGetOn;
  int *numRidersToGetOff;
 private:
  Direction direction;
  int numFloors;
};

extern void StartElevatorSimulation();

#endif












