// system.h -- routines for starting up and halting Nachos
//     plus, all the global variables in Nachos 
//
// Copyright (c) 1992 The Regents of the University of California.
// All rights reserved.  See copyright.h for copyright notice and limitation 
// of liability and disclaimer of warranty provisions.

#include "copyright.h"

#ifndef SYSTEM_H
#define SYSTEM_H


#ifdef CHANGED
#include "alarm.h"
#endif

  // Initialize is called before doing anything.
extern void Initialize(int argc, char **argv);
  // Cleanup is called by Interrupt::Halt to shut everything down
extern void Cleanup();

class Thread;
class Scheduler; 
class Interrupt;
class Statistics;
class Timer;

extern Thread* currentThread;	// the thread we are running now
extern Thread* threadToBeDestroyed;  // the thread that just finished
extern Scheduler* scheduler;	// the ready list
extern Interrupt *interrupt;	// interrupt status
extern Statistics* stats;	// performance metrics
extern Timer *timer;

#ifdef HW2
class Machine;
class FileSystem;

extern Machine* machine;	// user program memory and registers
extern FileSystem  *fileSystem;
#endif

#ifdef HW4
class SynchDisk;

extern SynchDisk   *synchDisk;
#endif

#ifdef HW5
class PostOffice;

extern PostOffice* postOffice;
#endif

#endif




















