// water.cc - implementation of HW1, prob 5


#include "water.h"
#include "thread.h"
#include "alarm.h"
#include "stats.h"
#include "interrupt.h"
#include "thread.h"
#include "system.h"


extern "C" {
#include <stdlib.h>
#include <time.h>
}


//    ***GENERAL IDEA***
//
//  There are two condition vars:  okHToGo and okOToGo.
//  An arriving Hydrogen atom signals the oxygen queue and
//  blocks on okHtogo.  When an oxygen atom arrives it
//  blocks on okOtoGo until there are two Hydrogen atoms
//  waiting.  It then signals them and makes water.
  



static void StartWater(int i);
static Reaction *reaction = new Reaction();


Reaction::Reaction() {
  reactionLock = new Lock("Reaction Lock");
  okHToGo = new Condition("okHToGo");
  okOToGo = new Condition("okOToGo");
  numHwaiting = 0;
}


void Reaction::hReady() {
  reactionLock->Acquire();
  DEBUG('p', "Hydrogen\n");
  numHwaiting++;
  okOToGo->Signal(reactionLock);
  okHToGo->Wait(reactionLock);
  reactionLock->Release();
  currentThread->Finish();
}


void Reaction::oReady() {

  reactionLock->Acquire();
  DEBUG('p', "Oxygen\n");
  while (numHwaiting < 2)
    okOToGo->Wait(reactionLock);
  numHwaiting -= 2;
  okHToGo->Signal(reactionLock);
  okHToGo->Signal(reactionLock);
  makeWater();
  reactionLock->Release();
  currentThread->Finish();
}


void Reaction::makeWater() {
  DEBUG('p', "Water was made\n");
}


void TurnOnFaucet() {
  Thread *t;

  for (int i = 0; i < 35; i++) {
    t = new Thread("forked thread");
    t->Fork(StartWater, i);
  }
}
  

void StartWater(int i) {
  alarm->GoToSleepUntil(stats->totalTicks + 500);
  srand((time(NULL) * i) % 1007);
  i = (rand() % 10007) % 3;
  if (i == 2) 
    reaction->oReady();
  else reaction->hReady();

}











