// alarm.cc -- contains the implementation of the alarm clock
// described in HW1 prob 3.


#include "system.hpp"
#include "synch.hpp"
#include "alarm.hpp"
Alarm *alarm = new Alarm();

Alarm::Alarm () {
  sleepers = new List;
}


void Alarm::GoToSleepUntil(long time) {
  Semaphore *sem = new Semaphore("alarm", 0);   
  IntStatus oldLevel = interruptObj->SetLevel(IntOff); 
  sleepers->SortedInsert(sem, time);
  (void) interruptObj->SetLevel(oldLevel);
  sem->P();
  delete sem;
}

//MAY ONLY BE CALLED FROM WITHIN THE INTERRUPT HANDLER

void Alarm::WakeUpSleepers() {
  long key;
  while (!alarm->sleepers->IsEmpty()) {
    Semaphore *sem = (Semaphore *)alarm->sleepers->SortedRemove(&key);
    if (key <= stats->totalTicks)
      sem->V();
    else {
      alarm->sleepers->SortedInsert(sem, key);   
      break;
    }
  }
}
