
// producers-consumers.cc    HW1 Prob #2
// Implementation of the Producers Consumers problem.


//        ***GENERAL IDEA*** 
//  We have implemented a circular buffer.  The read pointer points
//  to the last position read.  The write pointer points to the
//  last position written.  If the two pointers (integers actually)
//  are the same the buffer is either full or empty.  num_items
//  keeps track of how many items are in the buffer.


#include "producer.hpp"

static void CallFuncs(int which);

static CircleBuff* buffer = new CircleBuff(3, "buffy");


CircleBuff::CircleBuff(int buffsize, char* buffName) {
  buffer = new char[buffsize];
  circleLock = new Lock (buffName);
  okToPut = new Condition(buffName);
  okToGet = new Condition(buffName);
  in = 0;
  out = 0;
  size = buffsize;
  num_items = 0;
}


void CircleBuff::putBuff(char letter) {
  buffer[in] = letter;
  in = ++in % size;
  num_items++;
} 


char CircleBuff::getBuff() {
  char letter = buffer[out];
  out = ++out % size; 
  num_items--;
  return letter;
}  


bool CircleBuff::isFull(){
  if (num_items == size) 
    return TRUE;
  else 
    return FALSE;
}


bool CircleBuff::isEmpty(){
  if (num_items == 0) 
    return TRUE;
  else return FALSE;
}


Producer::Producer(char* input, int newName) {
  message = input;
  name = newName;
}

Consumer::Consumer(int newName) {
  name = newName;
}



void Producer::FeedToBuff(CircleBuff* buff) {
  while (*message) {
    buff->circleLock->Acquire();
    
    while (buff->isFull())
      buff->okToPut->Wait(buff->circleLock);

    buff->putBuff(*message);

    if (!buff->isEmpty())
      buff->okToGet->Signal(buff->circleLock);

    buff->circleLock->Release();
    message++;
  }
}
      

void Consumer::EatFromBuff(CircleBuff* buff) {

  for(int i=0; i < 12; i++) {
    buff->circleLock->Acquire();

    while (buff->isEmpty())
      buff->okToGet->Wait(buff->circleLock);

    putchar(buff->getBuff());

    if (!buff->isFull())
      buff->okToPut->Signal(buff->circleLock);

    buff->circleLock->Release();
  }
}


void CallFuncs(long which) {

  char* hw = "Hello World";
  
  if (which % 2 == 1) {
    Producer* prod = new Producer(hw, which);
    prod->FeedToBuff(buffer);
  } else {
    Consumer* com = new Consumer(which);
    com->EatFromBuff(buffer);
  }
  
}
  

void ProdCom() {
  Thread *t;
  
  for (long i = 1; i <= 20; i++) {
    t = new Thread("forked thread");
    t->Fork(CallFuncs, i);
  }
}





