
// producers-consumers.cc   HW1 Prob #2
// Implementation of the Producers Consumers problem.


#ifndef P2_H
#define P2_H

#include "utility.hpp"
#include "synch.hpp"


class CircleBuff {
 public:
  CircleBuff(int buffsize, char* buffName);
  void putBuff(char letter);
  char getBuff();
  bool isFull();
  bool isEmpty();
  Lock* circleLock;
  Condition *okToGet, *okToPut;
 private:
  char* buffer;
  int in;
  int out;
  int size;
  int num_items;
};


class Producer {
 public:
  Producer(char* input, int newName);
  void FeedToBuff(CircleBuff* buff);
 private:
  char* message;
  int name;
};

class Consumer {
 public:
  Consumer(int name);
  void EatFromBuff(CircleBuff* buff);
 private:
  int name;
};


extern void ProdCom();

#endif
