    .MODEL large, c
        .data
 
        ALIGN   2
        
        .code
    PUBLIC  ThreadRoot

;
; expects the stack to look like this
;   [bp+2]  ->      thread object address segment       
;   [bp+0]  ->      thread object address offset
;
; this is set up by Thread::StackAllocate


ThreadRoot  PROC FAR C

        pop     bx              ; retrieve thread address offset from the stack
        pop     es              ; retrieve thread address segment from the stack

        push    es              ; save thread address segment on the stack
        push    bx              ; save thread address offset on the stack

        call    DWORD PTR es:[bx+24]    ; StartupPC
        
        pop     bx              ; retrieve thread address offset from the stack
        pop     es              ; retrieve thread address segment from the stack
        
        push    es              ; save thread address segment on the stack
        push    bx              ; save thread address offset on the stack

    push    es:[bx+34]  ; push InitialArg (4 bytes) onto stack for InitialPC
    push    es:[bx+32]  ; first push segment, then offset

        call    DWORD PTR es:[bx+28]    ; InitialPC

        pop     bx              ; retrieve thread address offset from the stack
        pop     es              ; retrieve thread address segment from the stack
        
        push    es              ; save thread address segment on the stack
        push    bx              ; save thread address offset on the stack

        call    DWORD PTR es:[bx+36]    ; WhenDonePC
        
    ; NOT REACHED
        ret


ThreadRoot  ENDP



; void SWITCH( thread *t1, thread *t2 )
;
; on entry the active stack looks like this:
;       [sp+10] ->      thread t2 segment
;       [sp+8]  ->      thread t2 offset
;       [sp+6]  ->      thread t1 segment
;       [sp+4]  ->      thread t1 offset      
;       [sp+2]  ->      return address CS
;       [sp+0]  ->      return address IP
;
; the stack of the dormant thread is expected to look like this:
;       [sp+2]  ->      return address segment (CS)
;       [sp+0]  ->      return address offset  (IP)
;

                .DATA
_ax_save        WORD   0
_es_save        WORD   0
_bx_save        WORD   0
_bp_save        WORD   0


                .code
    PUBLIC  SWITCH
SWITCH PROC FAR C
        mov     _ax_save,ax     ; save AX 
        mov     _bx_save,bx     ; save BX
        mov     _bp_save,bp     ; save BP
        mov     _es_save,es     ; save ES


    ; set up base pointer to t1's stack
        mov     bp,sp           


    ; Load t1 address into BX (offset) & ES (segment)

        mov     bx,[bp+6]       ; move t1 segment into BX
        mov     es,bx           ; now we can move t1 segment into ES

        mov     bx,[bp+4]       ; move t1 offset into BX


    ; Save t1 registers into t1 object

        mov     es:[bx],sp      ; save SP
        mov     es:[bx+2],ss    ; save SS
  
        mov     es:[bx+4],ax    ; save AX
        
        mov     ax,_bx_save     ; get saved value of BX into AX
        mov     es:[bx+6],ax    ; save BX
        
        mov     es:[bx+8],cx    ; save CX
        mov     es:[bx+10],dx   ; save DX

        mov     ax,_bp_save     ; get saved value of BP into AX
        mov     es:[bx+12],ax   ; save BP

        mov     es:[bx+14],si   ; save SI
        mov     es:[bx+16],di   ; save DI
        mov     es:[bx+18],ds    ; save DS
        
        mov     ax,_es_save     ; get saved value of ES into AX
        mov     es:[bx+20],ax   ; save ES
        

    ; Load t2 address into BX (offset) & ES (segment)

        mov     bx,[bp+10]      ; move t2 segment into BX
        mov     es,bx           ; now we can move t2 segment into ES

        mov     bx,[bp+8]       ; move t2 offset into BX


    ; Load t2 state into registers or temporary storage

        mov     ax,es:[bx+4]    ; get AX from t2
        mov     _ax_save,ax     ; save AX
        
        mov     ax,es:[bx+6]    ; get BX from t2
        mov     _bx_save,ax     ; save BX
        
        mov     cx,es:[bx+8]    ; get CX from t2 and load into CX register
        mov     dx,es:[bx+10]    ; get DX from t2 and load into DX register


        mov     bp,es:[bx+12]   ; get BP from t2 and load into BP register
        mov     si,es:[bx+14]   ; get SI from t2 and load into SI register
        mov     di,es:[bx+16]   ; get DI from t2 and load into DI register
        ;mov     ds,es:[bx+18]   ; get DS from t2 and load into DS register
        mov     ax,es:[bx+20]   ; get ES from t2
        mov     _es_save,ax     ; save ES
        
        mov     ss,es:[bx+2]    ; set up stack segment for Thread 2 stack
        mov     sp,es:[bx]      ; set up new stack pointer for Thread 2's stack


    ; flush the temporary storage into the appropriate registers        

        mov     ax,_ax_save
        mov     bx,_bx_save
        mov     es,_es_save

        ret
SWITCH ENDP

        END
